<?php

namespace Pinpoint\ProductPersonalisation\Plugin\Ui\Model;

class Reader extends AbstractReader
{
    /**
     * Create xml config with php for enable\disable it from admin panel
     *
     * @param \Magento\Ui\Config\Reader $subject
     * @param array $result
     * @param array $arguments
     * @return array
     */
    public function afterRead(
        \Magento\Ui\Config\Reader $subject,
        $result
    ) {
        $availableActions = ['updateprice'];

        if ($this->moduleManager->isOutputEnabled('Pinpoint_ProductPersonalisation') &&
            isset($result['children']['listing_top']['children']['listing_massaction']['children']) &&
            isset($result['children']['pinpoint_pp_template_list_data_source'])
        ) {
            $children = &$result['children']['listing_top']['children']['listing_massaction']['children'];
            foreach($availableActions as $item) {
                if (array_key_exists($item, $children)) {
                    continue;
                }

                $children[$item] = $this->generateElement($item);
            }
        }
        return $result;
    }
}
